osg::ShaderComposer Class Reference

deprecated More...

`#include <ShaderComposer>`

Inheritance diagram for osg::ShaderComposer:

## Public Types

typedef std::vector< const osg::Shader * > | Shaders
Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }

## Public Member Functions

| ShaderComposer ()
| ShaderComposer (const ShaderComposer &sa, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
| META_Object (osg, ShaderComposer)
virtual osg::Program * | getOrCreateProgram (const ShaderComponents &shaderComponents)
virtual osg::Shader * | composeMain (const Shaders &shaders)
virtual void | addShaderToProgram (Program *program, const Shaders &shaders)
virtual void | releaseGLObjects (osg::State *state) const
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const =0
virtual Object * | clone (const CopyOp &) const =0
virtual bool | isSameKindAs (const Object *) const
virtual const char * | libraryName () const =0
virtual const char * | className () const =0
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
virtual void | resizeGLObjectBuffers (unsigned int)
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Types

typedef std::map< ShaderComponents, ref_ptr< Program > > | ProgramMap
typedef std::map< Shaders, ref_ptr< Shader > > | ShaderMainMap

## Protected Member Functions

virtual | ~ShaderComposer ()
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

ProgramMap | _programMap
ShaderMainMap | _shaderMainMap
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Detailed Description

deprecated

## Member Typedef Documentation

## ProgramMap

typedef std::map< ShaderComponents, ref_ptr<Program> > osg::ShaderComposer::ProgramMap

protected

## ShaderMainMap

typedef std::map< Shaders, ref_ptr<Shader> > osg::ShaderComposer::ShaderMainMap

protected

## Shaders

typedef std::vector< const osg::Shader* > osg::ShaderComposer::Shaders

## Constructor & Destructor Documentation

## ShaderComposer() [1/2]

osg::ShaderComposer::ShaderComposer | ( |  | ) |

Referenced by META_Object(), and ShaderComposer().

## ShaderComposer() [2/2]

osg::ShaderComposer::ShaderComposer | ( | const ShaderComposer & | sa,
|  | const CopyOp & | copyop = CopyOp::SHALLOW_COPY )

References ShaderComposer(), and osg::CopyOp::SHALLOW_COPY.

## ~ShaderComposer()

virtual osg::ShaderComposer::~ShaderComposer | ( |  | ) |

protected virtual

## Member Function Documentation

## addShaderToProgram()

virtual void osg::ShaderComposer::addShaderToProgram | ( | Program * | program,
|  | const Shaders & | shaders )

virtual

## composeMain()

virtual osg::Shader * osg::ShaderComposer::composeMain | ( | const Shaders & | shaders | ) |

virtual

## getOrCreateProgram()

virtual osg::Program * osg::ShaderComposer::getOrCreateProgram | ( | const ShaderComponents & | shaderComponents | ) |

virtual

## META_Object()

osg::ShaderComposer::META_Object | ( | osg | ,
|  | ShaderComposer | )

References ShaderComposer().

## releaseGLObjects()

virtual void osg::ShaderComposer::releaseGLObjects | ( | osg::State * |  | ) | const

virtual

If State is non-zero, this function releases any associated OpenGL objects for the specified graphics context. Otherwise, releases OpenGL objects for all graphics contexts.

Reimplemented from osg::Object.

## Member Data Documentation

## _programMap

ProgramMap osg::ShaderComposer::_programMap

protected

## _shaderMainMap

ShaderMainMap osg::ShaderComposer::_shaderMainMap

protected

The documentation for this class was generated from the following file:

- ShaderComposer